// Upraveny program pro mereni s modulem PZEM-004T 100A z knihovny
// zobrazovani hodnot je na LCD displeji tabletu
// vagnervlastimil@seznam.cz
// www.mojeelektronika.mzf.cz

#include <PZEM004Tv30.h>                                   // pripojeni knihovny pro ovladani PZEM 
PZEM004Tv30 pzem(11,12);                                   // PIN11 Arduino RXD na TXD PZEM , PIN12 Arduino TXD na RXD PZEM 

void setup() {                                             // setup
Serial.begin(9600);                                        // nastaveni kmunikace s bluetooth
}                                                          // setup

void loop() {                                              // hlavni smycka
float voltage = pzem.voltage();                            // nacteni registru pro hodnotu napeti
if(voltage != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Napeti: ");Serial.print(voltage);Serial.println(" V"); // zobrazeni hodnoty napeti na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku
Serial.println("Chyba data napeti");                       // zobrazeni zpravy chyba nactenych dat                          
}                                                          // konec smycky IF napeti
float current = pzem.current();                            // nacteni registru pro hodnotu proud 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Proud: ");Serial.print(current);Serial.println(" A"); // zobrazeni hodnoty proudu na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku   
Serial.println("Chyba data proud");                        // zobrazeni zpravy chyba nactenych dat   
}                                                          // konec smycky IF proud
float power = pzem.power();                                // nacteni registru pro hodnotu odberu ve WATTECH 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Odber: ");Serial.print(power);Serial.println(" W"); // zobrazeni hodnoty odberu na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku  
Serial.println("Chyba data odber");                        // zobrazeni zpravy chyba nactenych dat   
}                                                          // konec smycky IF odber
float energy = pzem.energy();                              // nacteni registru pro hodnotu spotreby v kWh 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Spotreba: ");Serial.print(energy,3);Serial.println(" kWh"); // zobrazeni hodnoty spotreby kWh na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku  
Serial.println("Chyba data spotreba");                     // zobrazeni zpravy chyba nactenych dat 
}                                                          // konec smycky IF spotreba kWh
float frequency = pzem.frequency();                        // nacteni registru pro hodnotu frekvence site 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Frekvence: ");Serial.print(frequency, 1);Serial.println(" Hz"); // zobrazeni hodnoty frekvence na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku  
Serial.println("Chyba data frekvence");                    // zobrazeni zpravy chyba nactenych dat  
}                                                          // konec smycky IF frekvence
float pf = pzem.pf();                                      // nacteni registru pro hodnotu kosinus FI site 
if(current != NAN){                                        // pokud je nacteni OK pokracuje na dalsim radku 
Serial.print("Ucinik: ");Serial.println(pf);               // zobrazeni hodnoty kosinus FI na displeji tabletu
} else {                                                   // pokud neni pravda pokracuje se na dalsim radku 
Serial.println("Chyba data Ucinik");                       // zobrazeni zpravy chyba nactenych dat  
}                                                          // konec smycky ucinik                                                     
Serial.println();                                          // vynechani radku pro dalsi nacteni 
delay(10000);                                              // casova prodleva pro dalsi nacteni dat
}                                                          // konec hlavni smycky LOOP
